/*
Foilist v1.2 by Sheldor.  02/20/2025  1492 bytes
a minibot with wave surfing and pattern matching
v1.2 -- movement, energy management, targeting

Foil is one of the three forms of modern sport fencing,
along with épée and sabre.  https://en.wikipedia.org/wiki/Foil_%28fencing%29

Credits:
	Movement : jk.mini.CunobelinDC 1.2, simonton.mini.WeeksOnEnd 1.10.4, kc.micro.WaveShark 0.5,
		kc.mega.BeepBoop 2.0,	kc.serpent.Hydra
	Targeting: kc.micro.WaveShark 0.5, jk.micro.Cotillion 0.8, pez.mini.Pugilist 2.5.1f
Also, a general thanks to all open source bot authors and contributors to the RoboWiki.

Foilist is released under the terms of the RoboWiki Public Code License (RWPCL) - Version 1.1.
see license here:  https://robowiki.net/wiki/RWPCL
*/

package sheldor.mini;

import robocode.*;
import robocode.util.Utils;
import java.awt.geom.*;     // for Point2D's
import java.lang.*;         // for Double and Integer objects
import java.util.ArrayList; // for collection of Waves
import java.awt.*;
import java.util.*;

public class Foilist extends AdvancedRobot {		

	static final int    GUESS_FACTORS = 100;
	static final int    MIDDLE_FACTOR = 16;
	
  private static final int MAX_BFT = 70;
  private static final int MAX_MATCH_LENGTH = 40;
  private static final double WALL_FEATURE = 0.17;//0.45;
  
	private static final int SCAN_LENGTH = 48;
	private static final int VELOCITY_WEIGHT = (SCAN_LENGTH * 3) / 2;
	
	private static final int VELOCITY_VALUE = 1;	
	
	private static final int WEIGHTS = 5;
	private static final int WEIGHT_LENGTH = 12;
	private static final int SCANS = 127;

  // static Wave[][] hitScans = new Wave[9][100000];
  // static int[] indices = new int[9];
   static ArrayList hitScans = new ArrayList();
   
   public static Point2D.Double myLocation;    
   public static Point2D.Double enemyLocation;

   public static ArrayList enemyWaves;
   public static ArrayList pastWaves = new ArrayList();;

   public static double enemyEnergy;
   public static final double WALL_STICK = 160;
      
   static double lastLatVel;
   static double lastAdvVel;
   static double previousLastLatVel;
   static double lastPreviousLastLatVel;
   static double lastLatVelChange;
   
	static double waveCount;
		
	static double velocity;
	static double lastVelocity;
	static int ticksSinceVelocityChange;
	static int previousTicksSinceVelocityChange;
	static int ticksSinceHit;
	
//	static double[] weightScores = new double[WEIGHTS];
	static int weightIndex;
	static double powerSinceLastHit;
	static double hits;
	static double decay;
	static int deathCount;
	static double threshold;
	
	static double directionDistance;
	static double previousDirectionDistance;
	
//	static int historyIndex = (150000 - SCAN_LENGTH);
//	static double[] history = new double[150001];
	
	static double lastFactor;
	
//	static int[][] factors = new int[8][GUESS_FACTORS];

	static ScannedRobotEvent e;
	
   public void run() {
      setAdjustGunForRobotTurn(true);
      setAdjustRadarForGunTurn(true);
    
      enemyWaves = new ArrayList();
     // pastWaves = new ArrayList();
	  
		//enemyEnergy = 102; 
		
	  setColors(java.awt.Color.white, java.awt.Color.black, java.awt.Color.lightGray);
	  
//		for (int i = 1; i < 1000; i++) System.out.println(100000 % i);
	  
	/*	do{
		
	      updateWaves();
			move();

		turnRadarRightRadians(1);
			
	}	while(true);*/
   } 
   
   public void onStatus(StatusEvent e){    
      setTurnRadarRightRadians(1); 
   }

   public void onScannedRobot(ScannedRobotEvent e) {
 	//	e = newE;
		     	int i;   
      double absoluteBearing;  
      double enemyDistance;  
      double tempIndex;
	  double bearing;
      double latVel;
		double bulletPower;  
	  
      Wave ew;

	
		//wave surfing based on CunobelinDC's
		
      (ew = new Wave()).direction = (//direction =
 (int)Math.signum(//(direction / 100.0) +
	  
			(//history[--historyIndex] = 
			
(latVel = (getVelocity()*Math.sin(bearing = e.getBearingRadians())))) + 1E-10));
 //     double advVel = (getVelocity()*Math.cos(absoluteBearing));
   	
      setTurnRadarRightRadians(Utils.normalRelativeAngle((absoluteBearing = (bearing) + getHeadingRadians()) - getRadarHeadingRadians()) * 2);
	  
      pastWaves.add(0,ew);
    
      addWave(enemyEnergy - (enemyEnergy = e.getEnergy()));
   
     // update after EnemyWave detection, because that needs the previous
     // enemy location as the source of the Wave
      
      enemyLocation = project((myLocation = new Point2D.Double(getX(), getY())), (ew.directAngle = absoluteBearing), (enemyDistance = e.getDistance()));
   
		updateWaves();
		  
		//	int deceleration;
//	if ((deceleration = (velocity - (velocity = (int)Math.abs(getVelocity())))) != 0
	//	if (lastVelocity != (lastVelocity = velocity)
	if (velocity != (velocity = getVelocity())
//	if (getVelocity() == 0
){
			//previousTicksSinceVelocityChange = ticksSinceVelocityChange;
			ticksSinceVelocityChange = 0;//deceleration;
			}
	
	double distance;
	double[] localScan;// =// (ew.scan = new double[9]);
//(ew.scan = Arrays.copyOfRange(history, historyIndex - 8, historyIndex + SCAN_LENGTH));
	//(localScan = (ew.scan = new double[12]))[1] = pastWaves.size();//waveCount;
	(localScan = (ew.scan = new double[9]))[1] = lastLatVel;//lastPreviousLastLatVel;//previousLastLatVel ;
		//-	(localScan[3] = lastLatVel = Math.abs(latVel));//Math.abs(latVel);//lastLatVel;
	//localScan[2] = lastLatVel;
	//localScan[3] = velocity >> 2;
	//localScan[1] = getRoundNum();
	localScan[2] = (lastLatVel = Math.abs(latVel));//lastPreviousLastLatVel = previousLastLatVel;//lastLatVelChange;//lastLatVel = Math.abs(latVel);
	//localScan[3] = fieldContains(enemyLocation, (absoluteBearing + Math.PI) + (ew.direction * (0.55)), enemyDistance);
	localScan[4] = ((distance = enemyDistance));// / 250.0);
	//localScan[7] = (enemyDistance);
	localScan[6] = ++ticksSinceVelocityChange;//Math.cbrt(--ticksSinceVelocityChange);//VELOCITY_HISTORY_TABLE.charAt(ticksSinceVelocityChange += 3);
	localScan[7] = velocity*
	Math.cos(bearing);//lastAdvVel;
	//localScan[10] = deathCount * Math.random();
	
	/*	i = 5;
		do{
			localScan[3] += fieldContains(enemyLocation, (absoluteBearing + Math.PI) + (ew.direction / 
			(short)MOVEMENT_WALL_TABLE.charAt(--i)), enemyDistance);
		}while(i > 0);*/
			
//		int[] wallScore = new int[3];
		i = 5;
		do{
			localScan[4 - Integer.signum(--i)] += fieldContains(enemyLocation, (absoluteBearing + Math.PI) + (ew.direction * (i * 0.223)), enemyDistance);
		}while(i > -4);
		
		
/*	double angle;
	double lowest = Double.POSITIVE_INFINITY;
tempIndex = (angle = (40 - Math.sqrt(enemyDistance)) / 10);
i = 1;

do {
		double test;
		if ((test = checkDanger(angle * i)) < lowest){
			tempIndex = angle * i;
			lowest = test;
		}
	}
	while (--i >= -1);*/

//	int span = 2 + (400 / (int)enemyDistance);
	double lowest = Double.POSITIVE_INFINITY;
tempIndex = (i = 2);
	do {
		double angle;
		double test;
		if ((test = checkDanger(
			angle = Math.cbrt((i * //6.375
8//5//((35 / Math.cbrt(enemyDistance)))
) )// * 1.5
//(Math.PI/2)
)) < lowest){
			tempIndex = angle;
			lowest = test;
		}
	}
	while (--i >= -2);	

	  	setAhead(0);
		if(tempIndex != 0){
		      double goAngle;
      setAhead(Math.cos(goAngle = 
wallSmoothing(myLocation, 
            absoluteBearing,
            tempIndex)
            - getHeadingRadians()) / 0);
      setTurnRightRadians(Math.tan(goAngle));
	  }
      
		//calculate wall proximity
		//possibly inspired by Pugilist
		int wallScore = 0;
	/*	double bulletVelocity = Rules.getBulletSpeed(bulletPower = //(240 / (int)enemyDistance) +
			Math.min(enemyEnergy / 4, BULLET_POWER_TABLE.charAt(
			((int)enemyDistance >> 5) * 127 + (int)getEnergy())
//((int)getEnergy() >> 2) * 127 + (int)enemyEnergy)
 / 100.01));*/
	/*	i = 4;
		do{
			wallScore += fieldContains(myLocation, absoluteBearing + ((8.0 / bulletVelocity) / i), enemyDistance)
				<< (1 + Integer.signum(i));
		} while(--i > -4);*/
		i = 24;
		do{
			wallScore += fieldContains(myLocation, absoluteBearing + (4.29//(60.0 / bulletVelocity) 
/ (short)WALL_TABLE.charAt(--i)), enemyDistance);
		} while(i > 0);
		

			//pattern matching based on kc.micro.WaveShark's
		   // Update log of enemy movements and pattern match
		      enemyHistory = String.valueOf(
        (char)(
            ((int)Math.round((e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing)) 
				//+ (Math.random() - 0.5)
				) << 5)
            | wallScore//(fieldContains(absoluteBearing + WALL_FEATURE, enemyDistance) << 1)
         //   | fieldContains(absoluteBearing - WALL_FEATURE, enemyDistance)
          )
        ).concat(enemyHistory);

		/*enemyHistory = String.valueOf(
        (char)(((8 + (int)Math.round
(e.getVelocity()*Math.sin(e.getHeadingRadians() - absoluteBearing))) * 37)
				
           + (8 + (int)//Math.round
(e.getVelocity() *
                Math.cos(e.getHeadingRadians() - absoluteBearing)))
				)).concat(enemyHistory);*/
  /*  enemyHistory = String.valueOf(
        (char)((
            ((int)Math.round((e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing)) 
				//+ (Math.random() - 0.5)
				) << 10)
            | (wallScore << 4)) + (8 + (int)//Math.round
((e.getVelocity()
				*Math.cos(e.getHeadingRadians() - absoluteBearing))))//(fieldContains(absoluteBearing + WALL_FEATURE, enemyDistance) << 1)
         //   | fieldContains(absoluteBearing - WALL_FEATURE, enemyDistance)
          )
        ).concat(enemyHistory);*/
		
	
		if (getGunHeat() <= 0.2){
    int matchLength = MAX_MATCH_LENGTH;//(int)(Math.ceil(Math.random() * MAX_MATCH_LENGTH));
		int matchPos;

	/*		char c;
			System.out.println((
        c = (char)((
            ((int)Math.round((e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing)) 
				//+ (Math.random() - 0.5)
				) << 9)
            | wallScore << 4) + 4 + (int)(e.getVelocity()*Math.cos(e.getHeadingRadians() - absoluteBearing)) / 2//(fieldContains(absoluteBearing + WALL_FEATURE, enemyDistance) << 1)
         //   | fieldContains(absoluteBearing - WALL_FEATURE, enemyDistance)
          )
        ));
		
		System.out.println((int)(e.getVelocity()*Math.cos(e.getHeadingRadians() - absoluteBearing))
		 + " " + ((c % 16) - 4));*/
			
 do{}
    while ((matchPos = enemyHistory.indexOf(
        enemyHistory.substring(0, (--matchLength)), MAX_BFT)) < 0);
		
	/*	if(getGunHeat() <= 0){System.out.println("\nmatchlength: " + matchLength);
	}*/
/*
			System.out.println(matchLength);
			System.out.println((int)Math.round((e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing))));			
			System.out.println( (char)(
            ((int)Math.round((e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing)) 
				//+ (Math.random() - 0.5)
				) << 5)
            | wallScore));			
			System.out.println("");*/
//}

		  do {
       absoluteBearing += Math.signum(enemyEnergy) * 
((short)enemyHistory.charAt(--matchPos) >> 5) / enemyDistance;  
		} while ((distance -= Rules.getBulletSpeed(bulletPower = //(240 / (int)enemyDistance) +
			Math.min(enemyEnergy / 4, BULLET_POWER_TABLE.charAt(
			((int)enemyDistance >> 5) * 127 + (int)getEnergy())
//((int)getEnergy() >> 2) * 127 + (int)enemyEnergy)
 / 100.01))
			) > 0);
	
	
		
		if (getEnergy() > 0.21)
		{
			setFire(bulletPower);
		}
		
}
	
    setTurnGunRightRadians(Utils.normalRelativeAngle(
        //(Math.cbrt(Math.random() ) * 0.02) +
	   (Math.random() * 0.007) +
		absoluteBearing - getGunHeadingRadians()));
		
	//	ticksSinceHit++;


   } 
    	
   public static void addWave(double deltaEnergy){		
		
      if (pastWaves.size() > 2 && (deltaEnergy > 0 || enemyWaves.isEmpty()
)){
		
         Wave ew;
         (ew = (Wave)pastWaves.get(2)).fireLocation = enemyLocation;
		 	
	/*  if (deltaEnergy > 0)// || enemyWaves.isEmpty())
      {		 
		ew.surf = ++waveCount;	
		enemyBulletSpeed = Rules.getBulletSpeed(deltaEnergy);
      }*/
	  	  //powerSinceLastHit += (
			ew.scan[8] = 2 * deltaEnergy;
		  ew.bulletVelocity = Rules.getBulletSpeed(deltaEnergy);
         enemyWaves.add(ew); 
//waveCount++;// += Math.sqrt(Math.random());		
		 //random = Math.random(); 
	 // depth = (int)(hitScans.size() / (1.25 / Math.random())); 
	  }
   }

 // CREDIT: mini sized predictor from Apollon, by rozu
 // http://robowiki.net?Apollon

   public  double checkDanger(double direction) {
	   
	Wave wave;// = null;
	int waveIndex = 0;
	double totalScore = 0;
	
	try{
	while(true){
	//Iterator it = enemyWaves.iterator();
//	while (it.hasNext()){
//  while (waveIndex < enemyWaves.size()){
	//	if ((wave = (Wave)it.next()).surf > 0)
//	{
      Point2D.Double predictedPosition = myLocation;
      double predictedVelocity;// = getVelocity();
      double predictedHeading = getHeadingRadians();
      double moveAngle = 0;//(predictedHeading = getHeadingRadians());

		double moveDir = -Math.signum(predictedVelocity = getVelocity());
      
      int counter = 0; // number of ticks in the future
	  
	  //wave = (Wave)enemyWaves.get(waveIndex);//(Wave)enemyWaves.get(waveIndex);
      do {
	//	  moveDir = 1;
			 
	  	 if(direction != 0){
		 moveDir = 1;
         if(Math.cos(moveAngle = wallSmoothing(predictedPosition,
			 absoluteBearing(predictedPosition,enemyLocation), direction) - predictedHeading) < 0) {
            moveAngle += Math.PI;
            moveDir = -1;
         
		 }
		/* else{
		 	moveDir = 1;
			}*/
			}
		else if (Math.abs(predictedVelocity) <= 2){
			counter = 127;
			}
      
       predictedPosition = project(predictedPosition,
            predictedHeading +=
            posNegLimit(Utils.normalRelativeAngle(moveAngle),
              Rules.getTurnRateRadians(Math.abs(predictedVelocity)))
             ,
              predictedVelocity = posNegLimit(predictedVelocity += (predictedVelocity * moveDir < 0 ? 2*moveDir : moveDir), 8)
              );
			  
		//	System.out.println(Math.copySign(8, direction));

	//	}
            
      } while(predictedPosition.distance((wave = (Wave)enemyWaves.get(waveIndex)).fireLocation)
      > wave.distanceTraveled + ++counter*wave.bulletVelocity);
	  
	  predictedVelocity = 1 - (predictedHeading = getFactor(wave, predictedPosition));
	  //predictedHeading = getFactor(wave,predictedPosition);
	  waveIndex++;
      if(wave.dist > (wave.bulletVelocity-22)){
	  //		int index;
		  int i = 0;//indices[index = (((int)wave.scan[3]))];//depth;
		  try{
			do{//if(i < SCANS)
{//while(i <= threshold){
         //Iterator i = hitScans.iterator();
        // while(i.hasNext()){
		/*	if (i > threshold){
				break;
				}*/
            double[] scan = //((Wave)hitScans[index][--i]).scan;
(double[])hitScans.get(i);
//i.next();

            double dist = (1/4000.0);
			int j = 1;
			do{
               dist += Math.pow
			   ((wave.scan[j] - scan[j])  / (double)WEIGHT_TABLE.charAt(//(weightIndex * WEIGHT_LENGTH) +
 j)
, 2
);
            }
			while(++j < scan.length);
			 predictedVelocity += (Math.cbrt(++i)//(1.0 / Math.cbrt(++i))//1.0//scan[1]//Math.pow(scan[1], random)
/(dist*(//0.25
//random
(1.0/50) 
+ Math.abs(predictedHeading - scan[0]))));
			//}
	//		i++;
			
		/*	if (Math.random() < 0.001){
			System.out.println(waveCount);
			System.out.println(scan[1]);
			System.out.println(dist);			
			System.out.println(scan[1] / dist);			
			System.out.println("");
			}*/
            }} while (true);//i < SCANS);
			}catch(Exception ex){}
    	totalScore += ((predictedVelocity) / predictedPosition.distanceSq(enemyLocation)) / waveIndex;//Math.pow(waveIndex, 2);
   // 	totalScore += predictedVelocity / Math.pow(predictedPosition.distance(enemyLocation) * (wave.dist + 150), 2);			  
  //    }
	  }
	  }
	}
	catch(Exception ex){}
	  return totalScore;
   }   

 // CREDIT: Iterative WallSmoothing by Kawigi
 //   - return absolute angle to move at after account for WallSmoothing
 // robowiki.net?WallSmoothing
   public static double wallSmoothing(Point2D.Double botLocation, double angle, double orientation) {
	   angle += orientation;
	   do{}
	   while (fieldContains(botLocation,( angle -= orientation*0.025)
		 , WALL_STICK) > 0);
      return angle;
   }
   
   public static void updateWaves() {
      Wave ew;
	  int i = 0;//enemyWaves.size();
   //   Iterator it = enemyWaves.iterator();
      
		try{
			while(true){
    //  while(it.hasNext()) {         
         
         if (((ew = (Wave)enemyWaves.get(i)).dist = 
		 myLocation.distance(ew.fireLocation)
   	 	  - (ew.distanceTraveled += ew.bulletVelocity )
         ) < -50) {
			// ew.factors[(int)getFactor(ew,myLocation)] += waveCount;
			// lastFactor = getFactor(ew,myLocation);

			enemyWaves.remove(i);
           // it.remove();
            continue;
         }		
		 i++; 
      }
	  }
	  catch(Exception ex){}
   }

 // Given the EnemyWave that the bullet was on, and the point where we
 // were hit, calculate the index into our stat array for that factor.
   public static double getFactor(Wave ew, Point2D.Double targetLocation) {
	//  return Utils.normalRelativeAngle(absoluteBearing(targetLocation, ew.fireLocation) - ew.directAngle) * ew.direction
   //      /  Math.asin(8.0/ew.bulletVelocity);
      return //(MIDDLE_FACTOR + 25) + 
(//MIDDLE_FACTOR * 
(Utils.normalRelativeAngle(absoluteBearing(targetLocation, ew.fireLocation) - ew.directAngle) * ew.direction
         /  Math.asin(8.0/ew.bulletVelocity)));
   }

   public void onBulletHitBullet(BulletHitBulletEvent e){
      logEnemyBullet(e.getHitBullet());
   }
   public void onHitByBullet(HitByBulletEvent e) {
     //threshold = 20 + (Math.random() * 100);// * 50;
      logEnemyBullet(e.getBullet());
      enemyEnergy += 20 - e.getVelocity();
	  //decay += e.getPower() / 125.0;
	  //weightIndex = (int)(Math.random() * WEIGHTS);
	  /*weightScores[weightIndex] += (e.getPower() / powerSinceLastHit);
	  int i = WEIGHTS;
	  try{
		  do{
			  if (weightScores[--i] < weightScores[weightIndex]){
				  weightIndex = i;
			  }
		  }while(true);		  
	  }
	  catch(Exception ex){}*/
	 /* if ((hits += e.getPower()) > (getRoundNum() * 4) + 10){
		  weightIndex = (int)(Math.random() * WEIGHTS);//weightIndex++;// += 12;
		  //hits = 0;
	  }*/
	 // powerSinceLastHit = 1;
	 // random = Math.round(3.0 * Math.random());//(1.0/30.0) * Math.sqrt(Math.random());
	 // System.out.println(weightIndex);
   }
   public void onBulletHit(BulletHitEvent e){
      enemyEnergy -= Rules.getBulletDamage(e.getBullet().getPower());
   }
  /* public void onDeath(DeathEvent e)
	{	
		random = Math.random();//(int)(MAX_MATCH_LENGTH * Math.random());
		//deathCount++;
	} */ 
   public static void logEnemyBullet(Bullet b){
            // look through the EnemyWaves, and find one that could've hit us.
      Point2D.Double hitLocation; 
	  int i = 0;//enemyWaves.size();
     // Iterator it = enemyWaves.iterator();
	  try{
      do{
         Wave ew;
         
         if (Math.abs((ew = (Wave)enemyWaves.get(i)).distanceTraveled
			 - (hitLocation =  new Point2D.Double(b.getX(), b.getY())).distance(ew.fireLocation)) <= 40) {
			ew.scan[0] = getFactor(ew, hitLocation);

			
			//ew.scan[1] = waveCount;//Math.pow(waveCount, decay);// * (1 + b.getPower());	

			//int index;
			//hitScans[index = ((int)ew.scan[3])][indices[index]++] = ew;
            hitScans.add(//0, 
ew.scan);	
			
             // We can remove this wave now, of course.
			 enemyWaves.remove(i);
            //it.remove();
         }
		 i++;
      }while (true);
	  }  
	  catch(Exception ex){} 
   }

 // This can be defined as an inner class if you want.
   static class Wave {
      Point2D.Double fireLocation;
      int direction;
	//  int surf;
      double[] scan;
	//  int[] factors;
	  double dist;
      double bulletVelocity, directAngle, distanceTraveled;
   }

 // CREDIT: from CassiusClay, by PEZ
 //   - returns point length away from sourceLocation, at angle
 // robowiki.net?CassiusClay
   public static Point2D.Double project(Point2D.Double sourceLocation, double angle, double length) {
      return new Point2D.Double(sourceLocation.x + Math.sin(angle) * length,
         sourceLocation.y + Math.cos(angle) * length);
   }

 // got this from RaikoMicro, by Jamougha, but I think it's used by many authors
 //  - returns the absolute angle (in radians) from source to target points
   public static double absoluteBearing(Point2D.Double source, Point2D.Double target) {
      return Math.atan2(target.x - source.x, target.y - source.y);
   }

   public static double posNegLimit(double value, double max) {
      return Math.max(-max, Math.min(value, max));
   }
   
	 private static int fieldContains(Point2D.Double source, double heading, double distance) {
    return Integer.signum(new Rectangle2D.Double(18, 18, 764, 564).outcode(
        project(source, heading, distance)));
  }
	
	public static final String WALL_TABLE = ""
//	+ (char)2 + (char)2 + (char)2 + (char)2
	/*+ (char)3 + (char)3 + (char)3 + (char)3
	+ (char)6 + (char)6 + (char)6 + (char)6
	//+ (char)12 + (char)12 + (char)12 + (char)12 + (char)12
	//+ (char)24 + (char)24 + (char)24 + (char)24 + (char)24
	+ (char)-3 + (char)-6// + (char)-12 + (char)-24;*/
	//+ (char)1 + (char)1 + (char)1 + (char)1 + (char)1
	//+ (char)20 + (char)20 + (char)20 + (char)20 //+ (char)2
	//+ (char)3 + (char)3 + (char)3 + (char)3 + (char)3
	//+ (char)4 + (char)4 + (char)4 + (char)4 + (char)4
	+ (char)6 + (char)6 + (char)6 + (char)6 + (char)6
	+ (char)10 + (char)10 + (char)10 + (char)10 + (char)10
//	+ (char)5 + (char)5 + (char)5 + (char)5 + (char)5
	//+ (char)7 + (char)7 + (char)7 + (char)7 + (char)7
	+ (char)15 + (char)15 + (char)15 + (char)15 + (char)15
	+ (char)30 + (char)30 + (char)30 + (char)30 + (char)30
	//+ (char)60 + (char)60 + (char)60 + (char)60 + (char)60
	+ (char)-6 + (char)-10 + (char)-15 + (char)-30
	;
	
	public static final String MOVEMENT_WALL_TABLE = ""
	+ (char)2 + (char)2
	+ (char)4 + (char)4
	+ (char)-3
	;
  
	static final String MAIN_WEIGHT = ""
/*	+ (char)1 + (char)2 + (char)2 + (char)1 
	+ (char)500 + (char)4 + (char)15 + (char)1;*/
	/*+ (char)1 + (char)1 + (char)1 + (char)1 
	+ (char)250 + (char)1 + (char)12 + (char)3;*/

	+ (char)1 + (char)1 + (char)1 + (char)1 
	+ (char)250 + (char)2 + (char)12 + (char)2 + (char)1 ;
	//+ (char)1 + (char)3 + (char)1 + (char)2 
	//+ (char)500 + (char)3 + (char)16 + (char)4;
	
	/*+ (char)1 + (char)3 + (char)1 + (char)1 
	+ (char)1 + (char)1 + (char)2 + (char)250 
	+ (char)12 + (char)2 + (char)3 + (char)8;*/	
	
	static final String FAST_SEGMENTATION_WEIGHT = ""
	+ (char)1 + (char)1 + (char)1 + (char)1
	+ (char)1 + (char)1 + (char)1 + (char)200 
	+ (char)10 + (char)8 + (char)100 + (char)5;	
	
	static final String SLOW_SEGMENTATION_WEIGHT = ""
	+ (char)1 + (char)5 + (char)1 + (char)1
	+ (char)1 + (char)1 + (char)1 + (char)200 
	+ (char)10 + (char)8 + (char)100 + (char)5;
	
	static final String LT_WEIGHT = ""
	+ (char)1 + (char)65535 + (char)100 + (char)1 
	+ (char)5 + (char)100 + (char)100 + (char)500 
	+ (char)1200 + (char)4 + (char)100 + (char)3;
	/*+ (char)1 + (char)65535 + (char)1 + (char)1 
	+ (char)1 + (char)1 + (char)2 + (char)250 
	+ (char)12 + (char)2 + (char)1 + (char)3;*/
	
	static final String PM_WEIGHT = ""
	+ (char)1 + (char)3 + (char)1 + (char)1
	+ (char)2 + (char)100 + (char)100 + (char)500 
	+ (char)8 + (char)2 + (char)100 + (char)3;
	
	static final String WEIGHT_TABLE = ""
	+ MAIN_WEIGHT + LT_WEIGHT + FAST_SEGMENTATION_WEIGHT + SLOW_SEGMENTATION_WEIGHT + PM_WEIGHT;	

	static final String BP300 = ""
	+ (char)300 + (char)300 + (char)300 + (char)300
	+ (char)300 + (char)300 + (char)300 + (char)300
	+ (char)300 + (char)300 + (char)300 + (char)300
	+ (char)300 + (char)300 + (char)300 + (char)300
	+ (char)300 + (char)300 + (char)300 + (char)300;	
	
	static final String BP250 = ""	
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250;
	
	static final String BP200 = ""	
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200;
		
	static final String BP150 = ""	
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150;
		
	static final String BP30 = ""
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30;
	
	static final String BP10 = ""	
	+ (char)10 + (char)10 + (char)10 + (char)10
	+ (char)10 + (char)10 + (char)10 + (char)10
	+ (char)10 + (char)10 + (char)10 + (char)10
	+ (char)10 + (char)10 + (char)10 + (char)10
	+ (char)10 + (char)10 + (char)10 + (char)10;		
	
	static final String CLOSE_DISTANCE = ""	
	+ BP300
	+ BP300
	+ BP300
	+ BP300
	+ BP300
	+ BP300
	
	+ (char)300 + (char)300 + (char)300 + (char)300
	+ (char)300 + (char)300 + (char)300;	
	
	static final String MID_CLOSE_DISTANCE = ""	
	+ (char)10 + (char)30 + (char)30 + (char)30
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)200 + (char)200 + (char)200 + (char)200	
	+ (char)250 + (char)250 + (char)250 + (char)250	
	
	+ BP250
	+ BP250
	+ BP250
	+ BP250
	+ BP250
	
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250;	
	
	static final String MID_DISTANCE = ""	
	+ (char)10 + (char)10 + (char)10 + (char)30
	+ (char)30 + (char)30 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150 + (char)150 + (char)150 + (char)150
	
	+ BP200
	+ BP200
	+ BP200
	+ BP250
	+ BP250
	
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250;	
	
	static final String MID_LONG_DISTANCE = ""	
	+ (char)10 + (char)10 + (char)10 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	
	+ BP200
	+ BP200
	+ BP200
	+ BP200
	+ BP250
	
	+ (char)250 + (char)250 + (char)250;	
	
	static final String LONG_DISTANCE = ""	
	+ (char)10 + (char)10 + (char)10 + (char)10
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	
	+ BP150
	+ BP150
	+ BP200
	+ BP200
	+ BP250
	
	+ (char)250 + (char)250 + (char)250;
		
	static final String HIGH_ENERGY = ""	
	+ (char)25 + (char)50 + (char)75 + (char)100
	+ (char)117 + (char)134 + (char)150 + (char)167
	+ (char)184 + (char)200 + (char)217 + (char)234	
	+ (char)250 + (char)267 + (char)284 + (char)300	
	
	+ BP250
	+ BP250
	+ BP250
	+ BP250
	+ BP250
	
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250 + (char)250
	+ (char)250 + (char)250 + (char)250;
	
	static final String MID_ENERGY = ""	
	+ (char)25 + (char)50 + (char)75 + (char)100
	+ (char)117 + (char)134 + (char)150 + (char)167
	+ (char)184 + (char)200 + (char)217 + (char)234	
	
	+ (char)250 + (char)250 + (char)250 + (char)250	
	+ (char)250 + (char)250 + (char)250 + (char)250	
	
		+ BP200	+ BP200
		+ BP200	+ BP200	+ BP200
	
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200;	
	
	static final String LOW_MID_ENERGY = ""	
	+ (char)25 + (char)50 + (char)75 + (char)100
	+ (char)117 + (char)134 + (char)150 + (char)167
	+ (char)184 + (char)200
	
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200
	+ (char)200 + (char)200 + (char)200 + (char)200
	
	+ BP150
	+ BP150
	+ BP150
	+ BP150
	+ BP150
	
	+ (char)150 + (char)150 + (char)150 + (char)150
	+ (char)150;
	

	static final String LOW_ENERGY = ""	
	+ (char)25 + (char)50 + (char)50 + (char)50
		
	+ BP30	
	+ BP30	
	+ BP30	
	+ BP30

	+ BP200 + BP200
	
	+ (char)200 + (char)200 + (char)200;
	
	static final String BULLET_POWER_TABLE = ""
	//0 * 127
	+ CLOSE_DISTANCE
	
	//1 * 127	
	+ CLOSE_DISTANCE
	
	//2 * 127	
	+ CLOSE_DISTANCE
	
	//3 * 127	
	+ MID_CLOSE_DISTANCE
	
	//4 * 127	
	+ MID_CLOSE_DISTANCE
	
	//5 * 127
	+ MID_CLOSE_DISTANCE
	
	//6 * 127
	+ MID_CLOSE_DISTANCE
	
	//7 * 127
	+ MID_CLOSE_DISTANCE
	
	//8 * 127
	+ MID_DISTANCE
		
	//9 * 127	
	+ MID_DISTANCE
	
	//10 * 127	
	+ MID_DISTANCE
	
	//11 * 127	
	+ MID_DISTANCE
	
	//12 * 127
	+ MID_DISTANCE
	
	//13 * 127
	+ MID_DISTANCE
	
	//14 * 127
	+ MID_LONG_DISTANCE
	
	//15 * 127
	+ MID_LONG_DISTANCE
	
	//16 * 127
	+ MID_LONG_DISTANCE
	
	//17 * 127
	+ MID_LONG_DISTANCE
	
	//18 * 127
	+ MID_LONG_DISTANCE
	
	//19 * 127
	+ MID_LONG_DISTANCE
	
	//20 * 127
	+ MID_LONG_DISTANCE
	
	//21 * 127
	+ MID_LONG_DISTANCE
	
	//22 * 127
	+ LONG_DISTANCE
	
	//23 * 127
	+ LONG_DISTANCE
	
	//24 * 127
	+ LONG_DISTANCE
	
	//25 * 127
	+ LONG_DISTANCE
	
	//26 * 127
	+ LONG_DISTANCE
	
	//27 * 127
	+ LONG_DISTANCE
	
	//28 * 127
	+ LONG_DISTANCE
	
	//29 * 127
	+ LONG_DISTANCE
	
	//30 * 127
	+ LONG_DISTANCE
	
	//31 * 127
	+ LONG_DISTANCE
	
	//32 * 127
	+ LONG_DISTANCE
	
	+ LONG_DISTANCE + LONG_DISTANCE + LONG_DISTANCE + LONG_DISTANCE + LONG_DISTANCE
	
	/*+ BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300
	+ BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300
	+ BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300
	+ BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300 + BP300*/;
	
 // log of enemy movement, initialize to something to avoid out-of-bounds
  static String enemyHistory = "" +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0;
}